package net.universe_factory.minecraft.test;

import net.minecraftforge.common.MinecraftForge;
import net.minecraftforge.event.terraingen.BiomeEvent.CreateDecorator;
import net.universe_factory.minecraft.test.generic.GenericWood;
import cpw.mods.fml.common.Mod;
import cpw.mods.fml.common.Mod.EventHandler;
import cpw.mods.fml.common.Mod.Instance;
import cpw.mods.fml.common.event.FMLInitializationEvent;
import cpw.mods.fml.common.eventhandler.SubscribeEvent;

@Mod(modid = Test.MODID, version = Test.VERSION)
public class Test {
	public static final String MODID = "neoraider_test";
	public static final String VERSION = "1";

	@Instance(value = MODID)
	public static Test instance;

	public static final GenericWood cherry = new GenericWood(new GenericWood.Info() {
		@Override
		public String getName() {
			return "Cherry";
		}

		@Override
		public int getMinTreeHeight() {
			return 4;
		}
	});

	@EventHandler
	public void preInit(FMLInitializationEvent event) {
		MinecraftForge.TERRAIN_GEN_BUS.register(new TerrainGenHandler());

		cherry.register();
	}

	public class TerrainGenHandler {
		@SubscribeEvent
		public void handleCreateDecorator(CreateDecorator event) {
			event.newBiomeDecorator = new TestBiomeDecorator(cherry);

			event.newBiomeDecorator.bigMushroomsPerChunk = event.originalBiomeDecorator.bigMushroomsPerChunk;
			event.newBiomeDecorator.cactiPerChunk = event.originalBiomeDecorator.cactiPerChunk;
			event.newBiomeDecorator.clayPerChunk = event.originalBiomeDecorator.clayPerChunk;
			event.newBiomeDecorator.deadBushPerChunk = event.originalBiomeDecorator.deadBushPerChunk;
			event.newBiomeDecorator.flowersPerChunk = event.originalBiomeDecorator.flowersPerChunk;
			event.newBiomeDecorator.generateLakes = event.originalBiomeDecorator.generateLakes;
			event.newBiomeDecorator.grassPerChunk = event.originalBiomeDecorator.grassPerChunk;
			event.newBiomeDecorator.mushroomsPerChunk = event.originalBiomeDecorator.mushroomsPerChunk;
			event.newBiomeDecorator.reedsPerChunk = event.originalBiomeDecorator.reedsPerChunk;
			event.newBiomeDecorator.sandPerChunk = event.originalBiomeDecorator.sandPerChunk;
			event.newBiomeDecorator.sandPerChunk2 = event.originalBiomeDecorator.sandPerChunk2;
			event.newBiomeDecorator.treesPerChunk = event.originalBiomeDecorator.treesPerChunk;
			event.newBiomeDecorator.waterlilyPerChunk = event.originalBiomeDecorator.waterlilyPerChunk;
		}
	}
}
